"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var inferno_1 = require("inferno");
var inferno_shared_1 = require("inferno-shared");
var utils_1 = require("./utils");
function renderStylesToString(styles) {
    if (inferno_shared_1.isStringOrNumber(styles)) {
        return styles;
    }
    else {
        var renderedString = '';
        for (var styleName in styles) {
            var value = styles[styleName];
            var px = inferno_shared_1.isNumber(value) && !inferno_1.internal_isUnitlessNumber.has(styleName) ? 'px' : '';
            if (!inferno_shared_1.isNullOrUndef(value)) {
                renderedString += utils_1.toHyphenCase(styleName) + ":" + utils_1.escapeText(value) + px + ";";
            }
        }
        return renderedString;
    }
}
function renderVNodeToStringAsync(vNode, parent, context, firstChild) {
    return __awaiter(this, void 0, void 0, function () {
        var flags, type, props, children, isClass, instance, childContext, nextVNode, nextVNode, renderedString, html, isVoidElement, prop, value, i, len, child, _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    flags = vNode.flags;
                    type = vNode.type;
                    props = vNode.props || inferno_1.EMPTY_OBJ;
                    children = vNode.children;
                    if (!(flags & 28 /* Component */)) return [3 /*break*/, 7];
                    isClass = flags & 4 /* ComponentClass */;
                    if (!isClass) return [3 /*break*/, 4];
                    instance = new type(props, context);
                    instance._blockSetState = false;
                    childContext = void 0;
                    if (!inferno_shared_1.isUndefined(instance.getChildContext)) {
                        childContext = instance.getChildContext();
                    }
                    if (!inferno_shared_1.isNullOrUndef(childContext)) {
                        context = inferno_shared_1.combineFrom(context, childContext);
                    }
                    if (instance.props === inferno_1.EMPTY_OBJ) {
                        instance.props = props;
                    }
                    instance.context = context;
                    instance._pendingSetState = true;
                    instance._unmounted = false;
                    if (inferno_shared_1.isFunction(instance.componentWillMount)) {
                        instance.componentWillMount();
                    }
                    if (!inferno_shared_1.isFunction(instance.fetchData)) return [3 /*break*/, 2];
                    return [4 /*yield*/, instance.fetchData()];
                case 1:
                    _c.sent();
                    _c.label = 2;
                case 2:
                    nextVNode = instance.render(props, vNode.context);
                    instance._pendingSetState = false;
                    // In case render returns invalid stuff
                    if (inferno_shared_1.isInvalid(nextVNode)) {
                        return [2 /*return*/, '<!--!-->'];
                    }
                    return [4 /*yield*/, renderVNodeToStringAsync(nextVNode, vNode, context, true)];
                case 3: return [2 /*return*/, _c.sent()];
                case 4:
                    nextVNode = type(props, context);
                    if (inferno_shared_1.isInvalid(nextVNode)) {
                        return [2 /*return*/, '<!--!-->'];
                    }
                    return [4 /*yield*/, renderVNodeToStringAsync(nextVNode, vNode, context, true)];
                case 5: return [2 /*return*/, _c.sent()];
                case 6: return [3 /*break*/, 22];
                case 7:
                    if (!(flags & 3970 /* Element */)) return [3 /*break*/, 21];
                    renderedString = "<" + type;
                    html = void 0;
                    isVoidElement = utils_1.isVoidElement(type);
                    if (!inferno_shared_1.isNullOrUndef(vNode.className)) {
                        renderedString += " class=\"" + utils_1.escapeText(vNode.className) + "\"";
                    }
                    if (!inferno_shared_1.isNull(props)) {
                        for (prop in props) {
                            value = props[prop];
                            if (prop === 'dangerouslySetInnerHTML') {
                                html = value.__html;
                            }
                            else if (prop === 'style') {
                                renderedString += " style=\"" + renderStylesToString(props.style) + "\"";
                            }
                            else if (prop === 'children') {
                                // Ignore children as prop.
                            }
                            else if (prop === 'defaultValue') {
                                // Use default values if normal values are not present
                                if (!props.value) {
                                    renderedString += " value=\"" + utils_1.escapeText(value) + "\"";
                                }
                            }
                            else if (prop === 'defaultChecked') {
                                // Use default values if normal values are not present
                                if (!props.checked) {
                                    renderedString += " checked=\"" + value + "\"";
                                }
                            }
                            else if (type === 'option' && prop === 'value') {
                                // Parent value sets children value
                                if (value === parent.props.value) {
                                    renderedString += " selected";
                                }
                            }
                            else {
                                if (inferno_shared_1.isStringOrNumber(value)) {
                                    renderedString += " " + prop + "=\"" + utils_1.escapeText(value) + "\"";
                                }
                                else if (inferno_shared_1.isTrue(value)) {
                                    renderedString += " " + prop;
                                }
                            }
                        }
                    }
                    if (!isVoidElement) return [3 /*break*/, 8];
                    renderedString += ">";
                    return [3 /*break*/, 20];
                case 8:
                    renderedString += ">";
                    if (!!inferno_shared_1.isInvalid(children)) return [3 /*break*/, 18];
                    if (!inferno_shared_1.isArray(children)) return [3 /*break*/, 14];
                    i = 0, len = children.length;
                    _c.label = 9;
                case 9:
                    if (!(i < len)) return [3 /*break*/, 13];
                    child = children[i];
                    if (!inferno_shared_1.isStringOrNumber(child)) return [3 /*break*/, 10];
                    renderedString += (child === '' ? ' ' : utils_1.escapeText(child));
                    return [3 /*break*/, 12];
                case 10:
                    if (!!inferno_shared_1.isInvalid(child)) return [3 /*break*/, 12];
                    _a = renderedString;
                    return [4 /*yield*/, renderVNodeToStringAsync(child, vNode, context, i === 0)];
                case 11:
                    renderedString = _a + _c.sent();
                    _c.label = 12;
                case 12:
                    i++;
                    return [3 /*break*/, 9];
                case 13: return [3 /*break*/, 17];
                case 14:
                    if (!inferno_shared_1.isStringOrNumber(children)) return [3 /*break*/, 15];
                    renderedString += (children === '' ? ' ' : utils_1.escapeText(children));
                    return [3 /*break*/, 17];
                case 15:
                    _b = renderedString;
                    return [4 /*yield*/, renderVNodeToStringAsync(children, vNode, context, true)];
                case 16:
                    renderedString = _b + _c.sent();
                    _c.label = 17;
                case 17: return [3 /*break*/, 19];
                case 18:
                    if (html) {
                        renderedString += html;
                    }
                    _c.label = 19;
                case 19:
                    if (!isVoidElement) {
                        renderedString += "</" + type + ">";
                    }
                    _c.label = 20;
                case 20: return [2 /*return*/, renderedString];
                case 21:
                    if (flags & 1 /* Text */) {
                        return [2 /*return*/, (firstChild ? '' : '<!---->') + (children === '' ? ' ' : utils_1.escapeText(children))];
                    }
                    else {
                        if (process.env.NODE_ENV !== 'production') {
                            if (typeof vNode === 'object') {
                                inferno_shared_1.throwError("renderToString() received an object that's not a valid VNode, you should stringify it first. Object: \"" + JSON.stringify(vNode) + "\".");
                            }
                            else {
                                inferno_shared_1.throwError("renderToString() expects a valid VNode, instead it received an object with the type \"" + typeof vNode + "\".");
                            }
                        }
                        inferno_shared_1.throwError();
                    }
                    _c.label = 22;
                case 22: return [2 /*return*/];
            }
        });
    });
}
function default_1(input) {
    return renderVNodeToStringAsync(input, {}, {}, true);
}
exports.default = default_1;
